```
███████╗██╗   ██╗██████╗ ███████╗██████╗
██╔════╝██║   ██║██╔══██╗██╔════╝██╔══██╗
███████╗██║   ██║██████╔╝█████╗  ██████╔╝
╚════██║██║   ██║██╔═══╝ ██╔══╝  ██╔══██╗
███████║╚██████╔╝██║     ███████╗██║  ██║
╚══════╝ ╚═════╝ ╚═╝     ╚══════╝╚═╝  ╚═╝
██████╗  ██████╗ ██╗    ██╗███████╗██████╗ ███████╗
██╔══██╗██╔═══██╗██║    ██║██╔════╝██╔══██╗██╔════╝
██████╔╝██║   ██║██║ █╗ ██║█████╗  ██████╔╝███████╗
██╔═══╝ ██║   ██║██║███╗██║██╔══╝  ██╔══██╗╚════██║
██║     ╚██████╔╝╚███╔███╔╝███████╗██║  ██║███████║
╚═╝      ╚═════╝  ╚══╝╚══╝ ╚══════╝╚═╝  ╚═╝╚══════╝
```

### What is JCB Super Powers?
The Joomla Component Builder (JCB) Super Power features are designed to enhance JCB's functionality and streamline the development process. These Super Powers enable developers to efficiently manage and share their custom powers across multiple JCB instances through repositories hosted on [https://git.vdm.dev/[username]/[repository-name]](https://git.vdm.dev). JCB Super Powers are managed using a combination of layers, events, tasks, methods, switches, and algorithms, which work together to provide powerful customization and extensibility options. More details on JCB Super Powers can be found in the [Super Powers Documentation](https://git.vdm.dev/joomla/super-powers/wiki).

In summary, JCB Super Powers offer a flexible and efficient way to manage and share functionalities between JCB instances. By utilizing a sophisticated system of layers, events, tasks, methods, switches, and algorithms, developers can seamlessly integrate JCB core powers and their custom powers. For more information on how to work with JCB Super Powers, refer to the [Super Powers User Guide](https://git.vdm.dev/joomla/super-powers/wiki).

### What can I find here?
This repository contains an index (see below) of all the approved powers within the JCB GUI. During the compilation of a component, these powers are automatically added to the repository, ensuring a well-organized and accessible collection of functionalities.

# Index of powers

- **Namespace**: [VDM\Joomla](#vdm-joomla)

  - **trait Utilities** | [Details](src/79d765b3-7319-4988-9730-446c7f347020) | [Code](src/79d765b3-7319-4988-9730-446c7f347020/code.php) | [Settings](src/79d765b3-7319-4988-9730-446c7f347020/settings.json) | [79d765b3-7319-4988-9730-446c7f347020](src/79d765b3-7319-4988-9730-446c7f347020)
- **Namespace**: [VDM\Joomla\Utilities](#vdm-joomla-utilities)

  - **abstract class ArrayHelper** | [Details](src/0a59c65c-9daf-4bc9-baf4-e063ff9e6a8a) | [Code](src/0a59c65c-9daf-4bc9-baf4-e063ff9e6a8a/code.php) | [Settings](src/0a59c65c-9daf-4bc9-baf4-e063ff9e6a8a/settings.json) | [0a59c65c-9daf-4bc9-baf4-e063ff9e6a8a](src/0a59c65c-9daf-4bc9-baf4-e063ff9e6a8a)
  - **abstract class FileHelper** | [Details](src/a223b31e-ea1d-4cdf-92ae-5f9becffaff0) | [Code](src/a223b31e-ea1d-4cdf-92ae-5f9becffaff0/code.php) | [Settings](src/a223b31e-ea1d-4cdf-92ae-5f9becffaff0/settings.json) | [a223b31e-ea1d-4cdf-92ae-5f9becffaff0](src/a223b31e-ea1d-4cdf-92ae-5f9becffaff0)
  - **abstract class GetHelper** | [Details](src/db87c339-5bb6-4291-a7ef-2c48ea1b06bc) | [Code](src/db87c339-5bb6-4291-a7ef-2c48ea1b06bc/code.php) | [Settings](src/db87c339-5bb6-4291-a7ef-2c48ea1b06bc/settings.json) | [db87c339-5bb6-4291-a7ef-2c48ea1b06bc](src/db87c339-5bb6-4291-a7ef-2c48ea1b06bc)
  - **abstract class GuidHelper** | [Details](src/9c513baf-b279-43fd-ae29-a585c8cbc4f0) | [Code](src/9c513baf-b279-43fd-ae29-a585c8cbc4f0/code.php) | [Settings](src/9c513baf-b279-43fd-ae29-a585c8cbc4f0/settings.json) | [9c513baf-b279-43fd-ae29-a585c8cbc4f0](src/9c513baf-b279-43fd-ae29-a585c8cbc4f0)
  - **abstract class JsonHelper** | [Details](src/4b225c51-d293-48e4-b3f6-5136cf5c3f18) | [Code](src/4b225c51-d293-48e4-b3f6-5136cf5c3f18/code.php) | [Settings](src/4b225c51-d293-48e4-b3f6-5136cf5c3f18/settings.json) | [4b225c51-d293-48e4-b3f6-5136cf5c3f18](src/4b225c51-d293-48e4-b3f6-5136cf5c3f18)
  - **abstract class MathHelper** | [Details](src/152c8793-8b75-4715-996a-257b9f65451c) | [Code](src/152c8793-8b75-4715-996a-257b9f65451c/code.php) | [Settings](src/152c8793-8b75-4715-996a-257b9f65451c/settings.json) | [152c8793-8b75-4715-996a-257b9f65451c](src/152c8793-8b75-4715-996a-257b9f65451c)
  - **abstract class ObjectHelper** | [Details](src/91004529-94a9-4590-b842-e7c6b624ecf5) | [Code](src/91004529-94a9-4590-b842-e7c6b624ecf5/code.php) | [Settings](src/91004529-94a9-4590-b842-e7c6b624ecf5/settings.json) | [91004529-94a9-4590-b842-e7c6b624ecf5](src/91004529-94a9-4590-b842-e7c6b624ecf5)
  - **abstract class StringHelper** | [Details](src/1f28cb53-60d9-4db1-b517-3c7dc6b429ef) | [Code](src/1f28cb53-60d9-4db1-b517-3c7dc6b429ef/code.php) | [Settings](src/1f28cb53-60d9-4db1-b517-3c7dc6b429ef/settings.json) | [1f28cb53-60d9-4db1-b517-3c7dc6b429ef](src/1f28cb53-60d9-4db1-b517-3c7dc6b429ef)
- **Namespace**: [VDM\Joomla\Utilities\Component](#vdm-joomla-utilities-component)

  - **abstract class Helper** | [Details](src/640b5352-fb09-425f-a26e-cd44eda03f15) | [Code](src/640b5352-fb09-425f-a26e-cd44eda03f15/code.php) | [Settings](src/640b5352-fb09-425f-a26e-cd44eda03f15/settings.json) | [640b5352-fb09-425f-a26e-cd44eda03f15](src/640b5352-fb09-425f-a26e-cd44eda03f15)

# Class Diagrams

## VDM Joomla
> namespace VDM\Joomla
```uml
@startuml

namespace VDM\Joomla #Azure {


  class Utilities << (T,Orange) >> #Turquoise {
    + static $langTag
    + {static} checkString() : bool
    + {static} shorten()
    + {static} safeString()
    + {static} safeClassFunctionName()
    + {static} safeFieldName()
    + {static} safeTypeName()
    + {static} safeNamespace()
    + {static} transliterate()
    + {static} htmlEscape()
    + {static} replaceNumbers()
    + {static} numberToString()
    + {static} randomkey() : string
    + {static} checkJson() : bool
    + {static} jsonToString()
    + {static} checkArray() : int
    + {static} mergeArrays()
    + {static} checkObject() : bool
    + {static} getVar() : mix
    + {static} getVars() : array
    + {static} getAllBetween() : array
    + {static} getBetween() : string
    + {static} bcmath() : float|int
    + {static} bcsum() : float|int
    + {static} createPluginClassName() : string
    + {static} GUID() : string
    + {static} validGUID() : bool
    + {static} getGUID() : mix
    # {static} validateGUID() : bool
    + {static} zip() : bool
    + {static} getFileContents() : string
    + {static} writeFile() : bool
    + {static} getAllFilePaths() : void
    + {static} getFilePath() : string
    + {static} urlExists() : bool
    + {static} setComponentOption()
  }
}


@enduml
```

## VDM Joomla Utilities
> namespace VDM\Joomla\Utilities
```uml
@startuml

namespace VDM\Joomla\Utilities #DarkCyan {


  abstract ArrayHelper  #Orange {
    + {static} check()
    + {static} merge() : ?array
    + {static} intersect() : bool
  }

  abstract FileHelper  #Orange {
    # static $curlError
    + {static} zip() : bool
    + {static} getContent() : string
    + {static} write() : bool
    + {static} getPaths() : void
    + {static} getPath() : string
    + {static} exists() : bool
  }

  abstract GetHelper  #Orange {
    + {static} var() : mixed
    + {static} vars() : ?array
    + {static} allBetween() : ?array
    + {static} between() : string
  }

  abstract GuidHelper  #Orange {
    + {static} get() : string
    + {static} valid() : bool
    + {static} item() : mix
    # {static} validate() : bool
  }

  abstract JsonHelper  #Orange {
    + {static} check() : bool
    + {static} string()
  }

  abstract MathHelper  #Orange {
    + {static} bc() : int
    + {static} sum() : float
  }

  abstract ObjectHelper  #Orange {
    + {static} check()
    + {static} equal() : bool
  }

  abstract StringHelper  #Orange {
    + static $langTag
    + {static} check() : bool
    + {static} shorten()
    + {static} safe()
    + {static} transliterate()
    + {static} html()
    + {static} numbers()
    + {static} number()
    + {static} random() : string
  }
}


@enduml
```

## VDM Joomla Utilities Component
> namespace VDM\Joomla\Utilities\Component
```uml
@startuml

namespace VDM\Joomla\Utilities\Component #Olive {


  abstract Helper  #Orange {
    + {static} getParams() : Registry
    + {static} getOption() : ?string
    + {static} getCode() : ?string
    + {static} get() : ?string
    + {static} methodExists() : bool
    + {static} _() : mixed
  }
}


@enduml
```


---
```
     ██╗ ██████╗  ██████╗ ███╗   ███╗██╗      █████╗
     ██║██╔═══██╗██╔═══██╗████╗ ████║██║     ██╔══██╗
     ██║██║   ██║██║   ██║██╔████╔██║██║     ███████║
██   ██║██║   ██║██║   ██║██║╚██╔╝██║██║     ██╔══██║
╚█████╔╝╚██████╔╝╚██████╔╝██║ ╚═╝ ██║███████╗██║  ██║
 ╚════╝  ╚═════╝  ╚═════╝ ╚═╝     ╚═╝╚══════╝╚═╝  ╚═╝
 ██████╗ ██████╗ ███╗   ███╗██████╗  ██████╗ ███╗   ██╗███████╗███╗   ██╗████████╗
██╔════╝██╔═══██╗████╗ ████║██╔══██╗██╔═══██╗████╗  ██║██╔════╝████╗  ██║╚══██╔══╝
██║     ██║   ██║██╔████╔██║██████╔╝██║   ██║██╔██╗ ██║█████╗  ██╔██╗ ██║   ██║
██║     ██║   ██║██║╚██╔╝██║██╔═══╝ ██║   ██║██║╚██╗██║██╔══╝  ██║╚██╗██║   ██║
╚██████╗╚██████╔╝██║ ╚═╝ ██║██║     ╚██████╔╝██║ ╚████║███████╗██║ ╚████║   ██║
 ╚═════╝ ╚═════╝ ╚═╝     ╚═╝╚═╝      ╚═════╝ ╚═╝  ╚═══╝╚══════╝╚═╝  ╚═══╝   ╚═╝
██████╗ ██╗   ██╗██╗██╗     ██████╗ ███████╗██████╗
██╔══██╗██║   ██║██║██║     ██╔══██╗██╔════╝██╔══██╗
██████╔╝██║   ██║██║██║     ██║  ██║█████╗  ██████╔╝
██╔══██╗██║   ██║██║██║     ██║  ██║██╔══╝  ██╔══██╗
██████╔╝╚██████╔╝██║███████╗██████╔╝███████╗██║  ██║
╚═════╝  ╚═════╝ ╚═╝╚══════╝╚═════╝ ╚══════╝╚═╝  ╚═╝
```
> Build with [Joomla Component Builder](https://git.vdm.dev/joomla/Component-Builder)

